# 🦆 QuACK: A Quirky Assortment of CuTe Kernels 🦆

Kernels are written in the [CuTe-DSL](https://docs.nvidia.com/cutlass/media/docs/pythonDSL/cute_dsl_general/dsl_introduction.html).

## Installation

``` bash
pip install quack-kernels
```

## Requirements

- H100 or B200 GPU
- CUDA toolkit 12.9+
- Python 3.12

## Kernels 🐥

- 🦆 RMSNorm forward
- 🦆 Softmax forward and backward
- 🦆 Cross entropy forward


## Usage

```
from quack import rmsnorm, softmax, cross_entropy
```

## Development

To set up the development environment:

```bash
pip install -e .[dev]
pre-commit install
```
